class Main {
  
float time;
Moto moto;
Circuit circuit;

boolean circuitVisible = true;
float force;
float delai;
float forcePlusTard;

float yLigne;
float tailleBornes;

float horizon;
float virage;
float rotondite;
float g;

float largeurRoute;
float aFactor;
float bFactor;

float tourneTete;
float aplat;


Main() {
  moto = new Moto();
  circuit = new Circuit();
}

void update() {

  // UPDATE
  time += moto.vitesse*2.3;
  time = time % circuit.longueur();
  
  
  force = circuit.getForceAtTime(time);
  delai = 60;
  if (delai > time) {
    forcePlusTard = force;
  } else {
    forcePlusTard = circuit.getForceAtTime(time-delai);
  }
  
  
  
  yLigne = 50;
  tailleBornes = 22;

  horizon      = 134;
  virage       = -force*2;
  rotondite    = 0;
  g            = 0.22;

  largeurRoute = 300;
  aFactor      = 0.88;
  bFactor      = 0.2;

  tourneTete   = virage/2;
  aplat        = horizon * aFactor;
  

  moto.modifPositionBy(forcePlusTard/200);
  moto.update();



  if (clic){ circuitVisible = !circuitVisible; }

  // DISPLAY

  if (circuitVisible) {displayCircuit();}
  displayRouteBezier();
  displayRoute();
    

  // display force
  //translate(0,-yLigne-horizon);
  //noFill(); stroke(255, 255, 255); strokeWeight(5);
  //ligne(new PVector(0,0),new PVector(-force,0));
  //translate(0,yLigne+horizon);

  // display moto
  translate(0,-yLigne);
  moto.display();
  translate(0,yLigne);
  
}






///////////////////////////////////////////////////////////////////
void displayRoute(){
  noFill(); stroke(136, 110, 79); strokeWeight(3); strokeCap(SQUARE);
  ligne (
     new PVector(-largeurRoute/2,yLigne), 
     new PVector( largeurRoute/2,yLigne)
  );
  ligne (
     new PVector(-largeurRoute/2,yLigne+tailleBornes/2), 
     new PVector(-largeurRoute/2,yLigne-tailleBornes/2)
  );
  ligne (
     new PVector( largeurRoute/2,yLigne+tailleBornes/2), 
     new PVector( largeurRoute/2,yLigne-tailleBornes/2)
  );
}


void displayCircuit(){
  float angle = - HALF_PI;
  translate(0,-yLigne-horizon+time);
  rotatePivot (new PVector(0,0), angle);

  circuit.display();  
  // on en dessine un autre pour le moment ou il se termine
  translate(circuit.longueur(),0);
  circuit.display();
  translate(-circuit.longueur(),0);

  rotatePivot (new PVector(0,0), -angle);
  translate(0,yLigne+horizon-time);
}


void displayRouteBezier(){
  // LA ROUTE BEZIER
  translate(0,-yLigne);

  noFill(); stroke(81, 82, 78); strokeWeight(2);
  ligneHorizontale(horizon);
  
  // 3 points pour le bas de la route 
  PVector basRouteMilieu = new PVector(0,0);
  PVector basRouteGauche = new PVector(-largeurRoute/2,0);
  PVector basRouteDroite = new PVector( largeurRoute/2,0);
  //fill(238,151,27); noStroke();
  //cercle(basRouteMilieu,10);
  //cercle(basRouteGauche,10);
  //cercle(basRouteDroite,10);  
  
  // 3 points pour le haut
  PVector but = new PVector(virage-tourneTete,horizon);
  PVector fuiteRoute = new PVector(-tourneTete*g,horizon);
  PVector batard = new PVector(fuiteRoute.x+(but.x-fuiteRoute.x)*bFactor,horizon+rotondite);
  //fill(232,222,192); noStroke(); cercle(but,10); 
  //fill(235,167,21); noStroke(); cercle(fuiteRoute,10);
  //fill(122,23,155); noStroke(); cercle(batard,7);
  
  // les lignes de fuite de la route, pour les ticons
  //noFill(); stroke(93,84,66);
  //ligne (basRouteMilieu, fuiteRoute);
  //ligne (basRouteGauche, fuiteRoute);  
  //ligne (basRouteDroite, fuiteRoute);

  // 3 points ticons
  PVector ticonMilieu = new PVector(basRouteMilieu.x+ aFactor*(fuiteRoute.x-basRouteMilieu.x),aFactor*horizon);
  PVector ticonGauche = new PVector(basRouteGauche.x+ aFactor*(fuiteRoute.x-basRouteGauche.x),aFactor*horizon);
  PVector ticonDroite = new PVector(basRouteDroite.x+ aFactor*(fuiteRoute.x-basRouteDroite.x),aFactor*horizon);
  //fill(238,151,27); noStroke();
  //cercle(ticonMilieu,5);
  //cercle(ticonGauche,5);
  //cercle(ticonDroite,5);
  
  // la route ! Les beziers
  noFill(); stroke(167,167,136);
  courbe(basRouteMilieu,ticonMilieu,batard,but);
  courbe(basRouteGauche,ticonGauche,batard,but);
  courbe(basRouteDroite,ticonDroite,batard,but);
  
  // display but
  fill(232,222,192); noStroke(); cercle(but,10); 

  translate(0,yLigne);
}



}
